SystemOrganization addCategory: #MagritteMagic!
SystemOrganization addCategory: #'MagritteMagic-Model'!
SystemOrganization addCategory: #'MagritteMagic-View'!

WAFileLibrary subclass: #MMFormRendererLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-View'!

!MMFormRendererLibrary methodsFor: 'form renderer files' stamp: 'NickAger 2/16/2012 10:48'!
formRendererCss
	^ '
textarea {
	width: 500px;
}

.icon a {outline: none; background: white;}
.search input.text {
	border: 1px solid white;
	color: black;}
.search input.text:focus {
	border: 1px solid #ff6633;
	color: black;}
.search input {
	color: #ff6633;
	font-size: 1em;
	outline: none;
	width: 98%;
	border: 0;
	margin-top: 0.1em;
	padding: 0.3em;
	padding-top: 0;
	background: 0;}
.search ul {
	margin: 0;
	padding: 0;
	background: white;
	list-style-type: none;
	border: 1px solid #ff6633;
	border-top: 0;}
.search li.selected a {color: #fff;}
.search li.selected {
	background-color: #ff6633;
	color: white;}
.search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;}
.menu ul {
	margin: 0;
	margin-top: 0.2em;
	padding-bottom: 0.2em;
	list-style-type: none;}
.menu ul li {
	display: inline;
	margin: 0;
	margin-right: 1.5em;
	list-style-type: none;}
.menu li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.5em;
	padding-bottom: 0.3em;}


/*BLOG*/
div.post {margin-bottom: 4.5em;}
div.comment {margin-bottom: 3em;}
.meta {font-size: 80%; color: #aaa;}
.leavecomment {margin-top: 4.5em; margin-bottom: 4.5em;}
.comments {margin-top: 4.5em;}


/* NAVIGATION */
.sidebar ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.sidebar ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.sidebar ul li {
	margin-top: 1.5em;}
.sidebar ul li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.3em;
	padding-bottom: 0.3em;}
.sidebar p,
.sidebar h1, .sidebar h2, .sidebar h3,
.sidebar .postticker .timestamp,
.sidebar .postticker .summary {padding-left: 0.3em;}
.sidebar .active,
.menu li a.active {
	color: white;
	background: #ff6633;}


/*MAIN BODY*/
.mainbody {
	padding-top: 4em;
	padding-bottom: 15em;}
.postticker ul {
	font-size: 80%;
	color: #aaa;
	list-style: none;
	margin-left: 0;}
.postticker ul li {
	margin-bottom: 1.5em;}
.postticker .timestamp {color: #aaa; font-size: 80%;}
.postticker .subscribe,
.postticker .timestamp .time,
.postticker .timestamp .author {display: none;}
.postticker a.post {color: #aaa;}


/* FOOTER */
.footer {
    color: #AAAAAA;
    font-size: 80%;
    text-align: left;
}
.footer a { color: #aaa;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}




/* META */
.metaenvironment h1.heading {display: none;}
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}


/*DEFAULT*/
body {margin-top: 0;}
h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: inherit; }
h1.heading { font-size: 2em; margin-bottom: 1.5em; }
h1 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
.maincontents {font-size: 1.5em;}
h2 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h3 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h4 { font-size: 1em; font-weight: bold; }
h5 { font-size: 1em; }
textarea {width: 100%;}
input.text, input.password {width: 200px;}
input[type="button"], input[type="submit"], input[type="reset"], input[type="file"], button { margin-left: 0.5em;} 


/* PIER */
.broken { color: red; font-weight: bold;}
.protected { color: #aaa; }
a {color: #ff6633;}
a:hover {
	color: white;
	background: #ff6633; }
a:hover.nobackground {background: white;}
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.left {text-align: left;}
.center {text-align: center;}
.float {float: right;}
.nobullets ul {list-style: none; margin-left: 0;}
.nobullets ul li {list-style: none; margin-left: 0;}
tr th {background: #eee; font-weight: normal;}
label {font-weight: normal;}
tr.group th {background: white; font-size: 1em; font-weight: bold; margin-top: 1.5em; }
td.required:after {color: #ff6633; content: "*"; margin-left: 0.5em;}


td.error {
  border:2px solid #ce0000;
}

table {
	border-spacing: 0px;
}

th {
	border-color: gray;
}
//body {
//	margin-left: 200px;
//}
#sidebar {
	font-family:Verdana, Geneva, sans-serif;
	font-size:11px;
	color:#000;
    height: 1000px;
    left: 0;
    position: fixed;
    top: 0;
    width: 200px;
	background:#fff;
	border-left:1px solid #ccc;
}
#sidebar a {
	color:#000;
}
#sidebar a:hover {
	background:none;
}
#sidebar h2 {
	margin: 5px 0 10px;
}
#sidebar .block {
	border-bottom: 2px solid #DDDDDD;
    overflow: hidden;
    padding: 0;
}
#sidebar #header .pierLogo {
	background: url("logoPier.png") no-repeat scroll 8px 5px transparent;
    height: 52px;
    width: 100px;
}
#sidebar #header .logout {
	background: url("process-stop.png") no-repeat scroll right 1px transparent;
    float: right;
    left: 130px;
    padding: 2px 19px 2px 0;
    position: absolute;
    top: 14px;
}

#sidebar #browser {
	
}
#sidebar #browser .add {
	background: url("list-add.png") no-repeat scroll 0 2px transparent;
    display: block;
    margin: 4px 0 4px 4px;
    padding-left: 20px;
    text-decoration: underline;
}
#sidebar #browser li {
}
#sidebar #browser ul {
    padding-left: 15px;
}
#sidebar #browser ul.view {
	background: none repeat scroll 0 0 #EEEEEE;
    border-top: 1px solid #EEEEEE;
    height: 375px;
    margin: 0;
    overflow-x: hidden;
    overflow-y: scroll;
    padding-left: 0;
}
#sidebar #browser .menuItem {
	background: none no-repeat scroll 3px 3px transparent;
    display: inline;
    float: left;
    padding: 3px 0 3px 22px;
    width: 175px;
}

#sidebar #browser .menuItem.active {
	background-color: #CCCCCC;
    color: #333333;
    font-weight: bold;
	/*border-radius: 10px;*/
    
}
#sidebar #browser .menuItem.page {
	background-image: url("text-html.png");
}
#sidebar #browser .menuItem.system {
	background-image: url("applications-system.png");
}
#sidebar #browser .menuItem.management {
	background-image: url("preferences-system.png");
}
#sidebar #browser .menuItem.components {
	background-image: url("package-x-generic.png");
}
#sidebar #browser .menuItem.templates {
	background-image: url("x-office-document-template.png");
}

#sidebar #commands {
	
}
#sidebar #commands .button {
	display: inline;
    float: left;
    padding: 6px 0 6px 39px;
    width: 127px;
	text-decoration:underline
}
#sidebar #commands h2 {
	background: url("text-html.png") no-repeat scroll 3px 1px transparent;
    padding-left: 26px;
}
#sidebar #commands .breadCrumb {
	font-size:10px;
}
#sidebar #commands .edit {
	background: url("edit-page.png") no-repeat scroll 0 0 transparent;
    margin-bottom: 5px;
}

#tabs {
	font-family:Verdana, Geneva, sans-serif;
	font-size:11px;
}
#tabs a {
	color:#333;
}
#tabs a:hover {
	color:#000;
}
#tabs ul {
	margin: 0;
    overflow: hidden;
    width: 100%;
	padding:0;
}
#tabs ul li {
	float: left;
	display:inline;
    list-style: none outside none;
}
#tabs ul li a {
	background: url("tabNotactiveLeft.gif") no-repeat scroll 0 0 transparent;
    display: block;
    line-height: 19px;
    padding: 18px 15px 12px 23px;
}

#content iframe {
	width:100%;
	height:800px;
	border:none;
}	
	
ul.errors {
     display:none;
}

.MMMagritteFormRenderer
{
    margin: 10px 0 10px 0; 
    padding: 0;
    position: relative;
    -moz-border-radius:10px;
    -webkit-border-radius:10px;
    border-radius:10px;
    background:none repeat scroll 0 0 #f8f8f8;
    border-color:#f0f0f0;
    border-style:solid;
    border-width:2px;
    width: 580px;
    float: left;
}

div.buttons {
	clear: both;
}

.editProductPageRightColumn
{
    margin: 0px 0 0 10px; 
    position: relative; 
    float: left; 
    -moz-border-radius:10px;
    -webkit-border-radius:10px;
    border-radius: 10px;
    background:none repeat scroll 0 0;
    border-style:solid;
    border-width:2px;
    width: 358px;
    border: 0;
}

div.field-container
{
    padding: 5px 20px;
    clear: both;
    overflow: hidden;
}

div.field-container label
{
    clear: both;
    color: #71A4CA;
    display: inline;
    float: left;
}

div.field-container.highlighted
{
    background: #e8e8e8;
}

.editProjectField
{
    background: none repeat scroll 0 0 #e8e8e8;
    padding: 5px;
    margin-bottom: 10px;
    clear: both;
    float: left;
}	
	

div.field-container div.tooltip
{
    background: none;
    left: 585px;
    position: absolute;
    background: transparent;
    border: none;
    clear: both;
    padding: 0;
    width: 320px;
    line-height: 1.5;
    font-size: 12px;
    font-family: Arial,sans-serif;
    display: none;
    margin-bottom: 10px;
    z-index: 100;   
}

div.field-container.required label {
background: url(http://localhost:8096/templatefiles/0025Template/template/images/PNewProjRequired.png) no-repeat scroll 100% 20%;
padding-right: 70px;
clear: both;
float: left;
}

div.field-container div.tooltip dl
{
    background: #ffffff;
    -moz-border-radius: 10px;
    -moz-box-shadow: 0 0 2px #a0a0a0;
    border: 1px solid #d0d0d0;
    font-style: normal;
    margin-left: 13px;
    width: 95%;
}

div.field-container div.tooltip dt
{
    background: url("http://localhost:8096/templatefiles/0025Template/template/images/PNewProjInfoIcon.png") no-repeat scroll 8px 5px #71A4CA;
    -moz-border-radius-topleft: 10px;
    -moz-border-radius-topright: 10px;
    border: 1px solid #d0d0d0;
    font-weight: bold;
    margin: 0;
    color: #ffffff;
    padding: 5px 5px 5px 30px;
}

div.field-container div.tooltip-arrow
{
    background: url("http://localhost:8096/templatefiles/0025Template/template/images/PNewProjTooltipArrow.png") no-repeat scroll transparent;
    height: 28px;
    width: 17px;
    margin-left: -2px;
    top: 50px;
    position: absolute;
}

div.field-container div.tooltip dd
{
    font-size: 13px;
    font-style: normal;
    padding: 5px 12px 12px;
    margin: 0;
}

div.error {
color: #C00003;
}

div.error .editProjectField {
background-color: #FEE;
border: 0;
}

.editProjectField {
background: none repeat scroll 0 0 #E8E8E8;
padding: 5px;
margin-bottom: 10px;
clear: both;
float: left;
}
'! !

!MMFormRendererLibrary methodsFor: 'form renderer files' stamp: 'NickAger 2/16/2012 10:39'!
formRendererJs
	^ '
$(function() {addHandlerToInputs()});

function addHandlerToInputs() {
	$("input:not(input[type=checkbox], input[type=submit]), textarea, select").focus(function() {showTooltip(this)} );
	$("input, textarea, select").blur( function() {hideTooltip(this)} );
}

function showTooltip(el)
{
	el = $(el);
	
	var container = el.closest(".field-container");
	container.addClass("highlighted");
	
	var label = container.find("label");
	var tooltip = container.find(".tooltip");

	var tooltipPosY = label.position().top;
	// tooltipPosY -= parseInt(label.css("line-height")); /*IE returns "normal" */
	tooltipPosY -= 20;
	
	if ( $(".tooltip-arrow",tooltip).length == 0 ) {
		tooltip.prepend(''<div class="tooltip-arrow"></div>'');
	}

	tooltip.css({
		"top": tooltipPosY
	}).show();
}

function hideTooltip(el)
{
	el = $(el);
	var container = el.closest(".field-container");
	
	container.removeClass("highlighted");
	container.find(".tooltip").hide();
}
'! !

!MMFormRendererLibrary methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 10:40'!
selectorsToInclude
	^ #( formRendererJs formRendererCss )! !

WAComponent subclass: #MMConferenceComponent
	instanceVariableNames: 'conference conferenceComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-View'!

!MMConferenceComponent class methodsFor: 'as yet unclassified' stamp: 'NickAger 2/16/2012 14:17'!
label 
	^'New Conference'! !

!MMConferenceComponent methodsFor: 'hooks' stamp: 'NickAger 2/16/2012 11:24'!
children 
	^Array with: self conferenceComponent! !

!MMConferenceComponent methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 11:21'!
conference
	^ conference! !

!MMConferenceComponent methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 11:21'!
conference: anObject
	conference := anObject! !

!MMConferenceComponent methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 11:26'!
conferenceComponent
	^ conferenceComponent ifNil: [ 
		conferenceComponent := MMConference new asComponent 
			addValidatedForm;
			addMessage: self class label;
			onAnswer: [ :v | self answer: v ];
			yourself ]! !

!MMConferenceComponent methodsFor: 'updating' stamp: 'NickAger 2/16/2012 10:49'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	MMFormRendererLibrary default updateRoot: anHtmlRoot! !

WAComponent subclass: #MMTalkComponent
	instanceVariableNames: 'talkComponent talk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-View'!

!MMTalkComponent class methodsFor: 'as yet unclassified' stamp: 'NickAger 2/16/2012 14:17'!
label 
	^ 'New Talk'! !

!MMTalkComponent methodsFor: 'hooks' stamp: 'NickAger 2/16/2012 11:17'!
children 
	^Array with: self talkComponent! !

!MMTalkComponent methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 04:46'!
talk 
	^talk ifNil: [ talk := MMTalk new ]. ! !

!MMTalkComponent methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 04:46'!
talk: aTalk
	talk := aTalk! !

!MMTalkComponent methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 11:26'!
talkComponent 
	^ talkComponent ifNil: [ 
		talkComponent := self talk asComponent 
			addValidatedForm;
			addMessage: self class label;
			onAnswer: [ :value | self answer: value ];
			yourself ]! !

!MMTalkComponent methodsFor: 'updating' stamp: 'NickAger 8/25/2011 13:20'!
updateRoot: anHtmlRoot 
	anHtmlRoot addStyle: 'textarea {
	width: 500px;
}'! !

WAComponent subclass: #MMWebApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-View'!

!MMWebApplication class methodsFor: 'registration' stamp: 'NickAger 2/15/2012 15:45'!
initialize 
	self registerApplication! !

!MMWebApplication class methodsFor: 'registration' stamp: 'NickAger 2/16/2012 11:51'!
registerApplication
	(WAAdmin register: self asApplicationAt: 'magrittemagic')
		addLibrary: JQDevelopmentLibrary;
		addLibrary: JQUiDevelopmentLibrary;
		addLibrary: JQUiLightnessTheme;
		addFilterFirst: MMRestFilter new;
		yourself   
	! !

!MMWebApplication methodsFor: 'rendering' stamp: 'NickAger 2/16/2012 11:04'!
children
	^ Array with: self componentDefinedByRestFilter! !

!MMWebApplication methodsFor: 'accessing' stamp: 'NickAger 2/16/2012 11:04'!
componentDefinedByRestFilter
	^ self requestContext properties at: #displayComponent ifAbsent: [ nil ]! !

!MMWebApplication methodsFor: 'rendering' stamp: 'NickAger 2/19/2012 09:15'!
renderContentOn: html
	| potentialComponentDefinedByRestFilter |
	
	potentialComponentDefinedByRestFilter := self componentDefinedByRestFilter.
	potentialComponentDefinedByRestFilter notNil
		ifTrue: [ html render: potentialComponentDefinedByRestFilter ]
		ifFalse: [ self renderDemoListOn: html ].
		
	self renderSampleLinksOn: html.
	self renderMorphicCodeOn: html
	
	! !

!MMWebApplication methodsFor: 'rendering' stamp: 'NickAger 2/19/2012 10:34'!
renderDemoListOn: html
	html heading 
		level1; 
		with: 'Magritte Seaside Demo'.
		
	html emphasis: 'Make sure you use UTF-8 encoding in your Seaside server adaptor (right-click on the port in the Seaside Control Panel and select "Encoding...")'.

	html unorderedList: [
		html listItem: [ 
			html anchor 
				callback: [ 
					(self call: MMConferenceComponent new) ifNotNil: [ :newConference | MMConference add: newConference ] ];
				with: MMConferenceComponent label ].
		html listItem: [ 
			html anchor 
				callback: [ 
					(self call: MMTalkComponent new) ifNotNil: [ :newTalk | MMTalk add: newTalk ] ];
				with: MMTalkComponent label ] ]! !

!MMWebApplication methodsFor: 'rendering' stamp: 'NickAger 2/19/2012 09:16'!
renderMorphicCodeOn: html
	html heading level2 with: 'Generate a Morphic Form'.

	html paragraph: 'Execute the following in a workspace:'.

	html code: '(MMConference new 
	location: ''Informatics forum'';
	talks: MMTalk all;
	asMorph) 
		addWindow;
		callInWorld '
	
	! !

!MMWebApplication methodsFor: 'rendering' stamp: 'NickAger 2/16/2012 15:19'!
renderSampleLinksOn: html
	html heading level2 with: 'Sample links'.
	
	html unorderedList: [
		html listItem: [
			html anchor
				url: '/magrittemagic/conference?name=ESUG2011&format=xml';
				with: 'conference in xml' ].
		html listItem: [
			html anchor
				url: '/magrittemagic/conference?name=ESUG2011&format=json';
				with: 'conference in json' ].		
		html listItem: [
			html anchor
				url: '/magrittemagic/talk?title=Magritte%20Magic&format=xml';
				with: 'talk in xml' ].
		html listItem: [
			html anchor
				url: '/magrittemagic/talk?title=Magritte%20Magic&format=json';
				with: 'talk in json' ] ].
! !

!MAElementDescription methodsFor: '*magrittemagic' stamp: 'NickAger 2/14/2012 14:32'!
tooltip
	^self 
		propertyAt: #tooltip 
		ifAbsent: [ nil ]! !

!MAElementDescription methodsFor: '*magrittemagic' stamp: 'NickAger 2/14/2012 14:33'!
tooltip: aToolTip
	^ self propertyAt: #tooltip put: aToolTip! !

MAComponentRenderer subclass: #MMMagritteFormRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-View'!

!MMMagritteFormRenderer methodsFor: 'error-handling' stamp: 'NickAger 8/25/2011 09:06'!
errorsForDescription: aDescription do: aBlock
	component errors do: [:anError |
		anError tag = aDescription ifTrue: [ aBlock value: anError ] ]
! !

!MMMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 8/25/2011 10:34'!
renderContainer: aDescription
	"containing markup for all the forms fields" 
	html div
		class: (self classFor: aDescription);
		class: 'MMMagritteFormRenderer';
		with: [super renderContainer: aDescription]! !

!MMMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 8/25/2011 09:07'!
renderControl: aDescription
	html div
		class: 'editProjectField';
		with: [ 
			super renderControl: aDescription. 
			self errorsForDescription: aDescription do: [:error |
				html div
					class: 'errorMessage';
					with: error messageText ] ]! !

!MMMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 8/25/2011 09:07'!
renderElement: aDescription
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
		
	html div
		class: 'field-container';
		class: (self classFor: aDescription);
		 with: [ 
			self renderLabel: aDescription.
			self renderControl: aDescription.
			self renderToolTip: aDescription ]! !

!MMMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 8/25/2011 09:07'!
renderLabel: aDescription
	| label |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label.
	(self childAt: aDescription) hasLabelId
		ifTrue: [ label for: (self childAt: aDescription) labelId ].
	label with: [ html html: aDescription label; text: ':' ]! !

!MMMagritteFormRenderer methodsFor: 'rendering' stamp: 'NickAger 8/25/2011 10:24'!
renderToolTip:  aDescription
	aDescription comment notNil ifTrue: [
		html div
			class: 'tooltip';
			with: [
				html definitionList: [
					html definitionTerm: aDescription label.
					html definitionData: [ html html: aDescription comment ] ] ] ]
! !

WARestfulFilter subclass: #MMRestFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-View'!

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 8/25/2011 05:12'!
conference: name
	<get>
	<path: '/conference?name={name}'>
	<produces: 'text/html'>
	| conference theRequestContext |
	
	theRequestContext := self requestContext.
	conference := self conferenceFromName: name.
	theRequestContext properties at: #displayComponent put: (conference asComponent readonly: true).

	"pass onto Seaside"
	self noRouteFound: theRequestContext! !

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 8/25/2011 05:11'!
conference: name format: formatString
	<get>
	<path: '/conference?name={name}&format={formatString}'>


	formatString = 'xml' ifTrue: [ self conferenceXml: name ].
	formatString = 'json' ifTrue: [ self conferenceJson: name ].
	
	self conference: name! !

!MMRestFilter methodsFor: 'lookup' stamp: 'NickAger 2/14/2012 14:54'!
conferenceFromName: conferenceName
	^ MMConference all 
		detect: [ :each | each name  =  conferenceName ]
		ifNone: [ self requestContext respond: [ :response | response notFound ] ]! !

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 8/26/2011 13:58'!
conferenceJson: conferenceName
	<get>
	<produces: 'application/json'>
	<path: '/conference?name={conferenceName}'>
	
	| conference |
	conference := self conferenceFromName: conferenceName.
	self requestContext respond: [ :response |
		response 
			contentType: WAMimeType applicationJson;
			nextPutAll:  conference asJson ]! !

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 2/16/2012 13:51'!
conferenceXml: conferenceName
	<get>
	<produces: '*/xml'>
	<path: '/conference?name={conferenceName}'>
	
	| conference |
	conference := self conferenceFromName: conferenceName.
	self requestContext respond: [ :response |
		response 
			contentType: (WAMimeType main: 'application' sub: 'xml');
			nextPutAll: (conference asXmlExportableDefault: true) greaseString ].! !

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 8/25/2011 05:45'!
talk: talkTitle
	<get>
	<path: 'talk?title={talkTitle}'>
	<produces: 'text/html'>

	| product |
	product := self talkFromTitle: talkTitle.
	self requestContext fields at: #displayComponent put: (product asComponent readonly: true).
	
	"pass onto Seaside"
	self noRouteFound: self requestContext! !

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 8/25/2011 12:51'!
talk: talkTitle format: formatString
	<get>
	<path: '/talk?title={talkTitle}&format={formatString}'>
	
	formatString = 'xml' ifTrue: [ self talkXml: talkTitle ].
	formatString = 'json' ifTrue: [ self talkJson: talkTitle ].
	
	self talk: talkTitle! !

!MMRestFilter methodsFor: 'lookup' stamp: 'NickAger 8/25/2011 05:47'!
talkFromTitle: talkTitle	
	^ MMTalk all 
		detect: [ :each | each title = talkTitle ]
		ifNone: [ self requestContext respond: [ :response | response notFound ] ]! !

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 8/25/2011 05:47'!
talkJson: talkTitle
	<get>
	<produces: 'application/json'>
	<path: '/talk?title={talkTitle}'>
	
	| talk |
	talk := self talkFromTitle: talkTitle.
	self requestContext respond: [ :response |
		response 
			contentType: WAMimeType applicationJson;
			nextPutAll:  talk asJson ]! !

!MMRestFilter methodsFor: 'routes' stamp: 'NickAger 2/16/2012 13:51'!
talkXml: talkTitle
	<get>
	<produces: '*/xml'>
	<path: '/talk?title={talkTitle}'>
	
	| talk |
	talk := self talkFromTitle: talkTitle.
	self requestContext respond: [ :response |
		response 
			contentType: (WAMimeType main: 'application' sub: 'xml');
			nextPutAll: (talk asXmlExportableDefault: true) greaseString ]! !

GRObject subclass: #MMAttendee
	instanceVariableNames: 'name email bookingDate message invoicedPrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-Model'!

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:29'!
bookingDate
	^ bookingDate! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:29'!
bookingDate: anObject
	bookingDate := anObject! !

!MMAttendee methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:11'!
descriptionBookingDate
	<magritteDescription>
	^ MADateDescription new
		priority: 30;
		label: 'Booking date';
		tooltip: 'When the attendee booked';
		accessor: #bookingDate;
		default: Date today;
		yourself! !

!MMAttendee methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:12'!
descriptionEmail
	<magritteDescription>
	^ MAStringDescription new
		priority: 20;
		label: 'Email';
		accessor: #email;
		beRequired;
		yourself! !

!MMAttendee methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:21'!
descriptionInvoicedPrice
	<magritteDescription>
	^ MANumberDescription new
		priority: 40;
		label: self priceLabel;
		accessor: #invoicedPrice;
		tooltip: 'How much are we charging this attendee';
		beRequired;
		addCondition: [ :value | value > 0 ] labelled: 'Price must be greater than zero';
		yourself! !

!MMAttendee methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:12'!
descriptionMessage
	<magritteDescription>
	^ MAStringDescription new
		priority: 20;
		label: 'Message';
		accessor: #message;
		beRequired;
		yourself! !

!MMAttendee methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:12'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		priority: 10;
		label: 'Name';
		accessor: #name;
		beRequired;
		yourself! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/24/2011 07:55'!
email
	^ email! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/24/2011 07:55'!
email: anObject
	email := anObject! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:34'!
invoicedPrice
	^ invoicedPrice! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:34'!
invoicedPrice: anObject
	invoicedPrice := anObject! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/11/2011 18:06'!
message
	^ message! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/11/2011 18:06'!
message: anObject
	message := anObject! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/24/2011 07:55'!
name
	^ name
! !

!MMAttendee methodsFor: 'accessing' stamp: 'NickAger 8/24/2011 07:55'!
name: anObject
	name := anObject! !

!MMAttendee methodsFor: 'magritte-model-accessing' stamp: 'NickAger 2/19/2012 10:30'!
priceLabel
	"an example of label which is defined dynamically, for example
	the currency used could depend on the user's country of orgin.
	We simulate this with a random selection:."
	| currencies |
	currencies := Array with: $$ with: $ with: Character euro.
	
	^ 'Invoice price ', (currencies atRandom) greaseString! !

!MMAttendee methodsFor: 'printing' stamp: 'SeanDeNigris 6/11/2013 01:31'!
printOn: aStream

	aStream nextPutAll: name.! !

GRObject subclass: #MMConference
	instanceVariableNames: 'date attendees name location talks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-Model'!

MMConference class
	instanceVariableNames: 'conferences'!

MMConference class
	instanceVariableNames: 'conferences'!

!MMConference class methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:27'!
add: aConference
	self all add: aConference! !

!MMConference class methodsFor: 'accessing' stamp: 'NickAger 2/14/2012 14:59'!
all
	^ conferences ifNil: [ conferences := self demoConferences ]! !

!MMConference class methodsFor: 'sample data' stamp: 'NickAger 2/14/2012 14:59'!
demoAttendees
	^ OrderedCollection new 
		add:  (MMAttendee new 
			name: 'Esteban Lorenzano'; 
			email: 'estebanlm@gmail.com'; 
			invoicedPrice: '525'; 
			message: 'Two talks this year'; 
			bookingDate: (Date newDay: 5 month: 6 year: 2011);
			yourself);
		add: (MMAttendee new 
			name: 'Nick Ager'; 
			email: 'nick.ager@gmail.com'; 
			invoicedPrice: '525'; 
			message: 'Always leaves his talk preparation to the last minute'; 
			bookingDate: (Date newDay: 5 month: 7 year: 2011);
			yourself);
		yourself! !

!MMConference class methodsFor: 'sample data' stamp: 'NickAger 2/14/2012 15:00'!
demoConferences
	^ OrderedCollection new
	 	add:  (MMConference new 
				name: 'ESUG2011';
				date:  (Date newDay: 25 month: 8 year: 2011);
				location: 'Edinburgh, UK';
				talks: self demoTalks;
				attendees: self demoAttendees);
		add:  (MMConference new 
			name: 'Smalltalks 2011 ';
			date:  (Date newDay: 10 month: 11 year: 2011);
			location: 'Argentina, UK';
			talks: self demoTalks;
			attendees: self demoAttendees);
		yourself! !

!MMConference class methodsFor: 'sample data' stamp: 'NickAger 2/14/2012 14:59'!
demoTalks
	^ OrderedCollection new 
		add:  (MMTalk new title: 'Magritte Magic'; detail: 'Some fun things with Magritte'; yourself);
		add: (MMTalk new title: 'Reef update'; detail: 'Update on reef development'; yourself);
		yourself! !

!MMConference class methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 06:04'!
reset
	conferences := nil! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 06:39'!
attendees
	^ attendees ifNil: [ attendees := OrderedCollection new 
		add:  (MMAttendee new 
			name: 'Esteban Lorenzano'; 
			email: 'estebanlm@gmail.com'; 
			invoicedPrice: '525'; 
			message: 'Two talks this year'; 
			bookingDate: (Date newDay: 5 month: 6 year: 2011);
			yourself);
		add: (MMAttendee new 
			name: 'Nick Ager'; 
			email: 'nick.ager@gmail.com'; 
			invoicedPrice: '525'; 
			message: 'Always leaves his talk preparation to the last minute'; 
			bookingDate: (Date newDay: 5 month: 7 year: 2011);
			yourself);
		yourself ]! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 06:38'!
attendees: anAttendee
	attendees := anAttendee! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/11/2011 17:37'!
date
	^ date! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/11/2011 17:37'!
date: anObject
	date := anObject! !

!MMConference methodsFor: 'descriptions' stamp: 'NickAger 2/16/2012 09:47'!
descriptionAttendees
	<magritteDescription>
	^ MAToManyRelationDescription new
		priority: 50;
		label: 'Attendees';
		accessor: #attendees;
		classes: {MMAttendee};
		comment: 'enter the conference attendees';
		yourself! !

!MMConference methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:13'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: MMMagritteFormRenderer;
		yourself! !

!MMConference methodsFor: 'descriptions' stamp: 'SeanDeNigris 6/11/2013 12:24'!
descriptionDate
	<magritteDescription>
	^ MADateDescription new
		priority: 40;
		label: 'Date';
		accessor: #date;
		beRequired;
		default: Date today;
		componentClass: MAJQDateInputComponent;
		comment: 'Conference start date';
		yourself! !

!MMConference methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:13'!
descriptionLocation
	<magritteDescription>
	^ MAStringDescription new
		priority: 20;
		label: 'Location address';
		accessor: #location;
		comment: 'conference location';
		beRequired;
		yourself! !

!MMConference methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:13'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		priority: 10;
		label: 'Name';
		accessor: #name;
		beRequired;
		comment: 'Please enter your name';
		yourself! !

!MMConference methodsFor: 'descriptions' stamp: 'NickAger 2/16/2012 10:19'!
descriptionTalks
	<magritteDescription>
	^ MAMultipleOptionDescription new
		priority: 30;
		label: 'Talks';
		accessor: #talks;
		options: MMTalk all;
		reference: MMTalk new magritteDescription;
		componentClass: MAListCompositonComponent;
		comment: 'select the talks you want to schedule';
		beRequired;
		yourself! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 05:17'!
location
	^ location! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 05:17'!
location: aLocation
	location := aLocation! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 05:21'!
name
	^ name! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 05:22'!
name: aName
	name := aName! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 06:28'!
talks
	^ talks! !

!MMConference methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:20'!
talks: anObject
	talks := anObject! !

GRObject subclass: #MMSpeaker
	instanceVariableNames: 'name email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-Model'!

!MMSpeaker methodsFor: 'descriptions' stamp: 'SeanDeNigris 6/8/2013 23:39'!
descriptionEmail
	<magritteDescription>
	^ MAStringDescription new
		priority: 20;
		label: 'Email';
		accessor: #email;
		beRequired;
		yourself! !

!MMSpeaker methodsFor: 'descriptions' stamp: 'SeanDeNigris 6/8/2013 23:39'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		priority: 10;
		label: 'Name';
		accessor: #name;
		beRequired;
		yourself! !

!MMSpeaker methodsFor: 'accessing' stamp: 'SeanDeNigris 6/8/2013 23:39'!
email
	^ email! !

!MMSpeaker methodsFor: 'accessing' stamp: 'SeanDeNigris 6/8/2013 23:39'!
email: anObject
	email := anObject! !

!MMSpeaker methodsFor: 'accessing' stamp: 'SeanDeNigris 6/8/2013 23:39'!
name
	^ name
! !

!MMSpeaker methodsFor: 'accessing' stamp: 'SeanDeNigris 6/8/2013 23:39'!
name: anObject
	name := anObject! !

GRObject subclass: #MMTalk
	instanceVariableNames: 'detail title speaker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagritteMagic-Model'!

MMTalk class
	instanceVariableNames: 'talks'!

MMTalk class
	instanceVariableNames: 'talks'!

!MMTalk class methodsFor: 'accessing' stamp: 'NickAger 8/11/2011 18:00'!
add: aProduct
	self all add: aProduct! !

!MMTalk class methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 06:29'!
all
	^ talks ifNil: [ talks := OrderedCollection new 
		add:  (MMTalk new title: 'Magritte Magic'; detail: 'Some fun things with Magritte'; yourself);
		add: (MMTalk new title: 'Reef update'; detail: 'Update on reef development'; yourself);
		yourself ]! !

!MMTalk class methodsFor: 'accessing' stamp: 'NickAger 8/25/2011 06:05'!
reset
	talks := nil! !

!MMTalk methodsFor: 'descriptions' stamp: 'NickAger 2/15/2012 15:13'!
descriptionDetail
	<magritteDescription>
	^ MAMemoDescription new
		priority: 20;
		label: 'Detail';
		tooltip: 'Tell us what your article is, in detail';
		accessor: #detail;
		yourself! !

!MMTalk methodsFor: 'descriptions' stamp: 'SeanDeNigris 6/11/2013 12:42'!
descriptionSpeaker
	<magritteDescription>
	^ MAToOneRelationDescription new
		priority: 15;
		"componentClass: MAInternalEditorComponent;" "uncomment to edit inline"
		label: 'Speaker';
		tooltip: 'Speaker giving the talk';
		accessor: #speaker;
		classes: { MMSpeaker };
		default: MMSpeaker new;
		beRequired;
		yourself! !

!MMTalk methodsFor: 'descriptions' stamp: 'NickAger 2/16/2012 09:48'!
descriptionTitle
	<magritteDescription>
	^ MAStringDescription new
		priority: 10;
		label: 'Title';
		tooltip: 'Talk title';
		accessor: #title;
		beRequired;
		yourself! !

!MMTalk methodsFor: 'accessing' stamp: 'EstebanLorenzano 7/28/2011 15:36'!
detail
	^ detail! !

!MMTalk methodsFor: 'accessing' stamp: 'EstebanLorenzano 7/28/2011 15:36'!
detail: anObject
	detail := anObject! !

!MMTalk methodsFor: 'accessing' stamp: 'SeanDeNigris 6/8/2013 23:41'!
speaker
	^ speaker! !

!MMTalk methodsFor: 'accessing' stamp: 'SeanDeNigris 6/8/2013 23:41'!
speaker: anObject
	speaker := anObject! !

!MMTalk methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:32'!
title
	^title! !

!MMTalk methodsFor: 'accessing' stamp: 'NickAger 8/23/2011 20:32'!
title: anObject
	title := anObject! !
MMWebApplication initialize!
